<?php

class BackupMaintenanceStep extends MigrationStep
{
    function __construct()
    {
        parent::__construct(4, __("Copy and upload data",'aruba-wp-migration-tool') );
    }

    public function canBeDone()
    {
        return !empty($_SESSION['wp2wp-migration-token']) && !empty($_SESSION['wp2wp-jwt']) && $_SESSION['wp2wp-valid-requirements'];
    }

    public function draw()
    {

        //$errS3Conn = isset($_GET['err-s3-conn']);
        $errGenFolder = isset($_GET['err-gen-folder']);

        /*if ($errS3Conn) {
            echo "<p class='wp2wp-text-notification'>". __("Impossibile connettersi a S3", "migration-plugin") . "<p>";
        }*/

        if ($errGenFolder) {
            echo "<p class='wp2wp-text-notification'>" . __("Unable to create migration folder" , "aruba-wp-migration-tool") . "<p>";
        }
        echo "<div id='substep1'>
            <p> ".__('Click on “Continue” to enable us to copy your files to a temporary storage space and perform the checks required for a successful migration.', "aruba-wp-migration-tool"). "</p>
 <p class='wp2wp-text-notification'><b>" . __("Depending on the size of folders to be copied and the connection, this procedure may take several minutes." , "aruba-wp-migration-tool") . "</b></p>
            <form id='migrationpreparation' method='GET' action='" . esc_url(admin_url('admin-post.php')) . "'>
               
                <div>
                    <input type='checkbox' id='activeMaintenance' name='activeMaintenance' checked value='activeMaintenance'>
                    <label for='activeMaintenance' class='wp2wp-text-bold'>" . __("I want to place my WordPress site in Maintenance mode" , "aruba-wp-migration-tool") . "</label>
                    <p class='wp2wp-pl'>" . __("This WordPress site will be placed in maintenance mode, making it unavailable for use during the migration, thereby ensuring that data is synchronized correctly and there is no misalignment between the old and the new site. Activating this mode will mean that the site will only become active again once it is published.",'aruba-wp-migration-tool') . "</p> 
                </div>
                <input type='hidden' name='action' value='backup_maintenance'>
                <hr class='wp2wp-mb wp2wp-mt'>
                <input class='button-primary pull-right' type='submit' type='submit' value='".__("Continue","aruba-wp-migration-tool")."'>
                <a class='button-secondary pull-right wp2wp-mr' href='?page=aruba-wp-migration-tool-migration&step=3'>".__("Back","aruba-wp-migration-tool")."</a>
            </form>
            </div>
            
            <div id='substep2' style='display: none;'>
            <div class='wp2wp-panel' style='padding: 20px'>
                <h2 class='wp2wp-text-center actiontitle'>".__("Copying and uploading data","aruba-wp-migration-tool")."
                <span>.</span><span>.</span><span>.</span>
                </h2>
            
                <div id='LiteralBarraStato'>
                  <div class='status-bar'>
                  
                    <div class='status-line'></div>
                    <div id='0' class='status-dot orange' style='top:0%;'>
                      <div class='status-label current'>".__("Maintenance management","aruba-wp-migration-tool")." </div> </div>
                   
                    <div class='status-line'></div>
                    <div id='1' class='status-dot white' style='top:20%;'>
                      <div class='status-label'>".__("Database dump","aruba-wp-migration-tool")." </div> </div>
                    
                     <div class='status-line'></div>
                     <div id='2' class='status-dot white' style='top:40%;'>
                       <div class='status-label'>".__("Package creation","aruba-wp-migration-tool")."</div> 
                     </div>
            
                    <div class='status-line'></div>
                    <div id='3' class='status-dot white' style='top:60%;'>
                      <div class='status-label'>".__("Uploading packages","aruba-wp-migration-tool")." </div> 
                    </div>
              
                    
                    <div class='status-line'></div>
                    <div id='4' class='status-dot white' style='top:80%;'>
                      <div class='status-label'>".__("Check import service","aruba-wp-migration-tool")." </div> 
                    </div>
                
                    
                    <div class='status-line'></div>
                    <div id='5' class='status-dot white' style='top:100%;'>
                      <div class='status-label'>".__("Completion of preliminary operations","aruba-wp-migration-tool")." </div> 
                    </div>        
                  </div>
                </div>
                 <hr class='wp2wp-mt wp2wp-mb'>
                <p class='wp2wp-text-center'><b>".__("You must keep this page open so as not to interrupt the process.","aruba-wp-migration-tool")."</b></p>
                <p class='wp2wp-text-center'>".__("Depending on the size of the folders to be uploaded and your connection, the procedure may take up to a few minutes.","aruba-wp-migration-tool")."</p>
          </div>
</div>

<script>
jQuery(document).ready(function(){
     var poll_file_statusInterval=false;
      var c_ss='';
      var _c_step=0;
      var step_process_complete=false;
      
      var busy=false;
      var rep='';
      
     var poll_file_status = function() {
         if(!busy){
          jQuery.ajax({
            url: '".esc_url(admin_url('admin-ajax.php?action=preparemigrationdetail'))."',
            dataType:'json',
            type: 'get',
            timeout: 0,
            success: function(data) { 
             c_status=data.idStatus;
             
               if(_c_step<=5){
                 //console.log('START PROCESS STEP: '+_c_step);
                 translate_file_status(_c_step);
                 rep=doAjaxStep();
                 
               }else{
                 step_process_complete=true;
                 clearInterval(poll_file_statusInterval);
                 window.location.href='".admin_url(WP2WP_STEPS_URL[5])."';
               }
            },
            /*error: function() { // error logging
              //console.log('Error!');
              if(_c_step<=5){
              jQuery('#wp2wp.wrap>.notice').after('<div class=\"notice notice-error\" >'+
           '<p>".esc_html(__("An application error has occurred. We suggest you try again in a few minutes. For more information",'aruba-wp-migration-tool'))."<a href=\'#\'>".__("contact technical support",'aruba-wp-migration-tool')." </a></p></div>');
            
              clearInterval(poll_file_statusInterval);
              step_process_complete=true;
              jQuery('#substep1').show();
                jQuery('#substep2').hide();
                }
            }*/
          });
          }
        };
     
     
     async function doAjaxStep() {
         let _resp=false;
        busy=true;
        _resp= await jQuery.ajax({
                        type: 'GET',
                        url: '" . esc_url(admin_url('admin-ajax.php?action=start_step_process')) . "',
                        data: {step: _c_step },
                        timeout: 0,
                        success:function (dataprocess) {
                        //c_status
                          //console.log('FINISH PROCESS STEP: '+_c_step);
                          const obj = JSON.parse(dataprocess);
                         // console.log(obj.status );
                          if(obj.status!=false ){
                            _c_step++;
                            step_process_complete=false;   
                            busy=false;
                          }else{
                               step_process_complete=true;
                             clearInterval(poll_file_statusInterval);
                             jQuery.ajax({
                                    type: 'GET',
                                    url: '".esc_url(admin_url('admin-ajax.php?action=setmigrationerror'))."',
                                    async : false,
                                    success:function (dataprocess) {
                                            window.location.href='".admin_url(WP2WP_STEPS_URL[5])."';
                                    }
                              });
                              
                          }
                        },
                        error:function (request, status, error) {
                             step_process_complete=true;
                             clearInterval(poll_file_statusInterval);
                             jQuery.ajax({
                                    type: 'GET',
                                    url: '".esc_url(admin_url('admin-ajax.php?action=setmigrationerror'))."',
                                    async : false,
                                    success:function (dataprocess) {
                                            window.location.href='".admin_url(WP2WP_STEPS_URL[5])."';
                                    }
                              });
                
                        }
                  });
       return _resp;
}
    
    
    var translate_file_status=function(c_index){
          if(c_ss!==c_index ){
              cur_obj_index= jQuery('.status-dot.orange').attr('id');
              
              for(cur_obj_index; cur_obj_index<=c_index;cur_obj_index++){
                  if(jQuery('.status-dot#'+cur_obj_index).hasClass('orange'))
                    jQuery('.status-dot#'+cur_obj_index).removeClass('orange');
                  if(jQuery('.status-dot#'+cur_obj_index).hasClass('white'))
                    jQuery('.status-dot#'+cur_obj_index).removeClass('white');
                  if(!jQuery('.status-dot#'+cur_obj_index).hasClass('black'))
                    jQuery('.status-dot#'+cur_obj_index).addClass('black');
                  if(jQuery('.status-dot#'+cur_obj_index+'>.status-label').hasClass('current'))
                    jQuery('.status-dot#'+cur_obj_index+'>.status-label').removeClass('current');
              }
              
              jQuery('.status-dot#'+(c_index)).removeClass('white');
              jQuery('.status-dot#'+(c_index)).addClass('orange');
              jQuery('.status-dot#'+(c_index)+'>.status-label').addClass('current');
              
              c_ss=c_index;
          }
    }
        
    
    jQuery('form#migrationpreparation').on('submit',function (event) {
     event.preventDefault();
     
     var formData = {
        action:'backup_maintenance',
        activeMaintenance: jQuery('#activeMaintenance').prop('checked'),
      };
        jQuery.ajax({
            type: 'GET',
            url: '".esc_url(admin_url('admin-post.php'))."',
            data: formData,
            success:function (data) {
                //console.log('FORM Inviata');
                jQuery('#substep1').hide();
                jQuery('#substep2').show();
                //start polling per vedere cosa sta facendo 
                poll_file_statusInterval = setInterval(function() { 
                  poll_file_status();
                  }, 5000);
                poll_file_status();
            }
        })
    
    });
    
    const onConfirmRefresh = function (event) {
      if (!step_process_complete){
        event.preventDefault();
        event.returnValue = '".__("By exiting the Aruba Migration Tool page, the migration procedure will be interrupted and all progress will be lost. Are you sure you want to proceed?","aruba-wp-migration-tool")."';
        if(event.returnValue){
            clearInterval(poll_file_statusInterval);
        }
        return event.returnValue;
      }
    }
    window.addEventListener('beforeunload', onConfirmRefresh, { capture: true });
})


</script>

";

    }
}
