<?php

class CheckFoldersStep extends MigrationStep
{
    function __construct()
    {
        parent::__construct(3, __("WordPress folders",'aruba-wp-migration-tool') );
    }
    public function canBeDone()
    {
        return !empty($_SESSION['wp2wp-migration-token']) && !empty($_SESSION['wp2wp-jwt']) && $_SESSION['wp2wp-valid-requirements'];
    }

    public function draw()
    {
        $dirContent = $this->getFolderContent();
        $requiredFinded = [];

        echo "<p>" . __("Select the folders you want to transfer to your new WordPress site." , "aruba-wp-migration-tool") . "</p>
<p>" . __("WordPress files must be included in the migration." , "aruba-wp-migration-tool") . "</p>
<p>" . __("Remember that:" , "aruba-wp-migration-tool") . "</p>
<p><ul style='list-style: square;list-style-position: inside;'>
<li>" . __("Cache folders are not used for migration, so we do not recommend selecting them" , "aruba-wp-migration-tool") . "</li>
<li>" . __("only active plugins will be migrated" , "aruba-wp-migration-tool") . "</li>
</ul></p>
              <form id='foldercheck' method='GET' action='" . esc_url(admin_url('admin-post.php')) . "'>
              <div class='wp2wp-panel' >
                <table class='wp2wp-folders-view'>
                <thead style='text-align: left;  height:30px;'>
                <tr>
                <th style='padding-left:100px;'>".__("File name","aruba-wp-migration-tool")."</th>
                <th>".__("Type","aruba-wp-migration-tool")."</th>
                <th>".__("Size","aruba-wp-migration-tool")." </th>
                </tr>
                </thead>
                
                <tbody >";

        foreach ($dirContent as $item) {
            $liClass = $item["isDir"] ? "is-dir" : "is-file";
            $valid = array_search($item["path"], REQUIRED_FOLDERS_FILES) === false;

            if (!$valid) {
                $r = [
                    "name" => $item["path"],
                    "path" => $item["abspath"]
                ];
                array_push($requiredFinded, $r);
                echo "<tr class='$liClass disabled' >
                       <td >
                        <input type='checkbox' checked='true' disabled>
                        <label>" . $item["path"] . "</label>
                    </td>
                    <td>".(is_dir($item["abspath"])?'Directory':'File'." ".pathinfo($item["abspath"], PATHINFO_EXTENSION) )."</td>
                     <td>" .(is_dir($item["abspath"])?$this->format_size($this->folderSize($item["abspath"])):$this->format_size(filesize($item["abspath"])) )."</td>
                    </tr>";
            } else {
                echo "<tr class='$liClass'>
                      <td >
                            <input type='checkbox' checked='true' id='" . $item["path"] . "' name='" . $item["path"] . "' value='" . $item["abspath"] . "'>
                            <label for='" . $item["path"] . "'>" . $item["path"] . "</label>
                        </td>
                        <td>".(is_dir($item["abspath"])?'Directory':'File'." ".pathinfo($item["abspath"], PATHINFO_EXTENSION) )."</td>
                    <td>" .(is_dir($item["abspath"])?$this->format_size($this->folderSize($item["abspath"])):$this->format_size(filesize($item["abspath"])) )."</td>
                        </tr>";
            }
        }
        echo "</tbody></table>
                </div>
                <p style='font-weight: bold;'>".__("Depending on the size of the folders to be uploaded and your connection, the procedure may take up to a few minutes.","aruba-wp-migration-tool")."</p>
                
                <input type='hidden' name='action' value='select_folders'>
                <hr class='wp2wp-mb wp2wp-mt'>
                 <button class='button-primary pull-right' type='button' id='submitbutton'><label>".__('Continue','aruba-wp-migration-tool')."</label>&nbsp;<i class='fa fa-circle-o-notch fa-spin' style='display:none'></i></button>
                <a class='button-secondary pull-right wp2wp-mr' href='?page=aruba-wp-migration-tool-migration&step=2'>".__("Back","aruba-wp-migration-tool")."</a>
            </form>";
        echo '
                <script>
                    jQuery(document).ready(function(){
                        
                        jQuery("#submitbutton").on("click",function(e,o){
                            //jQuery("label",o).hide();
                            jQuery("i",o).show(); 
                           jQuery("#foldercheck").trigger("submit");
                        });
                        
                        
                    })

                </script>';

        $_SESSION["required-folders"] = $requiredFinded;
    }
 private function folderSize ($dir)
{
    $size = 0;
    foreach (glob(rtrim($dir, '/').'/*', GLOB_NOSORT) as $each) {
        $size += is_file($each) ? filesize($each) : $this->folderSize($each);
    }

    return $size;
}

private function format_size($size) {
    $mod = 1024;
    $units = explode(' ','B KB MB GB TB PB');
    for ($i = 0; $size > $mod; $i++) {
        $size /= $mod;
    }

    return round($size, 2) . ' ' . $units[$i];
}
    private function getFolderContent()
    {
        $dirContent = array_diff(scandir(ABSPATH), array('.', '..'));
        // per rimuovere le cartele e i file da escludere 
        $dirContent = array_filter($dirContent, function ($var) {
            return  $var !== "." && $var !== ".." && array_search($var, EXCLUDED_FOLDERS_FILES) === false;
        });

        $dirContent = array_map(function ($v) {
            return ["isDir" => is_dir(ABSPATH . $v), "path" => $v, "abspath" => ABSPATH . $v];
        }, $dirContent);

        // per ordinare prima le cartelle e dopo i file
        usort($dirContent, function ($a, $b) {
            return $b['isDir'] - $a['isDir'];
        });

        return $dirContent;
    }
}
