<?php


class VerifyTokenStep extends MigrationStep
{
    function __construct()
    {
        parent::__construct(1, __("Token",'aruba-wp-migration-tool'));
    }

    function draw()
    {
        $msg = "";
        $errorMessage="";
        if (isset($_GET['err-gen'])) {
        echo "<div class='notice notice-error '> <!-- is-dismissible-->
        <p>".__("An application error has occurred. We suggest you try again in a few minutes. For more information",'aruba-wp-migration-tool')."<a href=\'#\'>".__("contact technical support",'aruba-wp-migration-tool')." </a></p>
        </div>";
        }

        if (isset($_GET['err-inv-token'])) {
            switch ($_GET['err-inv-token']) {
                case 42001:
                    $msg = __("Token does not exist.", "aruba-wp-migration-tool");
                    break;
                case 42002:
                    $msg = __("Token already used.", "aruba-wp-migration-tool");
                    break;
                case 42003:
                    $msg = __("Token expired.", "aruba-wp-migration-tool"); ;
                    break;
                default :
                    $msg="";
                    break;
            }
            //$errorMessage .= "<p class='wp2wp-text-notification'>$msg</p>";
        }

        $inputVaule = "";
        if (!empty($_SESSION['wp2wp-migration-token'])) {
            $inputVaule = $_SESSION['wp2wp-migration-token'];
        }

        echo "  <form id='verifytoken' name='verifytoken' method='GET' action='" . esc_url(admin_url('admin-post.php')) . "'>
                    <div class='insert-token-form-content'>
                        <div>
                            <label for='token-input'>" . __("Migration Token", "aruba-wp-migration-tool") . "</label>
                            <input type='text' placeholder='Aruba migration token' value='" . $inputVaule . "' id='token-input' name='token-input'>
                            <input type='hidden' name='action' value='add_token'>
                             <p class='wp2wp-text-notification'>$msg</p>
                        </div>
                        <div>
                            <b>" . __("Don’t have a token?", "aruba-wp-migration-tool") . "</b>
                            <p>" . __("Sign in to your Aruba Hosting customer area. Go to your domain control panel and click on WordPress Migration. Generate the token required in the Token area.", "aruba-wp-migration-tool") . "</p>
                        </div>
                    </div>
                    <hr class='wp2wp-mb wp2wp-mt'>
                    <button class='button-primary pull-right' type='button' id='submitbutton'><label>".__('Continue','aruba-wp-migration-tool')."</label>&nbsp;<i class='fa fa-circle-o-notch fa-spin' style='display:none'></i></button>
                </form>";
        if(isset($_GET['err-inv-token'])){
            echo '
                <script>
                    jQuery(document).ready(function(){
                        if(jQuery("#token-input").length){
                            jQuery("#token-input").addClass("border-danger");
                            //jQuery(".wp2wp-text-notification").html("Token non valido");
                            jQuery("#token-input").on("focus",function(){
                                jQuery(this).removeClass("border-danger");
                                jQuery(".wp2wp-text-notification").html("");
                            })
                        }
                       
                    })

                </script>';
        }

        echo '
                <script>
                    jQuery(document).ready(function(){
                       
                        jQuery("#submitbutton").on("click",function(e,o){
                            //jQuery("label",o).hide();
                             if(jQuery("#token-input").val()){
                                  jQuery("i",o).show(); 
                                jQuery("#verifytoken").trigger("submit");
                        }else{
                            jQuery("#token-input").addClass("border-danger");
                            jQuery(".wp2wp-text-notification").html("'.__("The token cannot be empty", "aruba-wp-migration-tool").'");
                           //document.forms["verifytoken"].submit();
                            jQuery("#token-input").on("focus",function(){
                                jQuery(this).removeClass("border-danger");
                                jQuery(".wp2wp-text-notification").html("");
                            })
                            }
                        });
                        
                       
                        
                        
                    })

                </script>';

    }
}
