<?php

class MigrationToolPage extends Page
{
    private $currentState;
    private $migrationSteps;

    function __construct()
    {
        // gli stati di migrazione associati agli step
        $this->migrationSteps = [
            new VerifyTokenStep(),
            new CheckRequirementsStep(),
            new CheckFoldersStep(),
            new BackupMaintenanceStep(),
            new ViewMigrationProgressStep()
        ];
    }

    function draw()
    {
        $step = isset($_GET['step']) ? $_GET['step'] : "1";
        $stepInt = intval($step);
        // Se è in corso una migrazione si fa redirect allo step 5 (se non è lo step richiesto)
        // ---- commentare l'if sotto se si vuole rilassare i vincoli di stato 
        if ($stepInt !== count($this->migrationSteps) && $GLOBALS["MIGRATION_FILE_MANAGER"]->isMigrationStarted()) {
            AdminPostActions::goToStep(count($this->migrationSteps));
            return;
        }
        // se lo step righiesto non è valido o non definito si fa redirect allo step 1
        if (!($stepInt > 0 && $stepInt <= count($this->migrationSteps))) {
            AdminPostActions::goToStep(1);
            return;
        }
        // se lo step richiesto non può essere ancora eseguito si fa redirect allo step 1
        if (!$this->migrationSteps[$stepInt - 1]->canBeDone()) {
            AdminPostActions::goToStep(1);
            return;
        }
        // setto lo step richiesto come il corrente
        $this->currentState = $this->migrationSteps[$stepInt - 1];
        $this->createProgressionBar();
        $this->currentState->draw();
        /*IF($stepInt == 5)
        {
            $processParams = $_SESSION['wp2wp-process-params'];
            $action = new AdminPostActions();
            $action->restartProcess();
            //$migrator->start();
        }*/
    }

    /**
     * Crea la progress bar degli step 
     */
    private function createProgressionBar()
    {
        echo "<ul class='wp2wp-state-progression-bar'>";
        foreach ($this->migrationSteps as $key => $val) {
            $lockedSTate = ($key < $this->currentState->order) ? "" : "locked";

            echo "<li class='$lockedSTate'><span class='badge '>" . ($val->order) . "</span>" ."<span class='badge-text '>". ($val->name)."</span>" . "</li>";
        }
        echo "</ul>";
    }
}
