<?php

use \GuzzleHttp\Client;

class MigratorStateCallOrchestrator extends MigratorState
{
    private $apiUrl;
    private $jwt;
    private $token;
    private $shouldBackup;
    function __construct($apiUrl, $jwt, $token, $shouldBackup)
    {
        parent::__construct("chiamata orchestratore");
        $this->apiUrl = $apiUrl;
        $this->jwt = $jwt;
        $this->token = $token;
        $this->shouldBackup = $shouldBackup;
    }

    /**
     * Avvia l'orchestratore
     */
    function execute()
    {
        $GLOBALS["PROCESS_LOG"]->writeLog("Migration Process - Chiamata orchestratore ");

        $url = $this->apiUrl . 'detail';
        $GLOBALS["PROCESS_LOG"]->writeLog($url);

        $headers = array(
            'Content-Type' => 'application/json',
            'Authorization' => "Bearer " . $this->jwt
        );
        /*$req = [
            'token' => $this->token,
            'backup' => $this->shouldBackup
        ];
        $headers = array(
            'Content-Type' => 'application/json',
            'Authorization' => "Bearer " . $this->jwt
        );
        $response = WpOrg\Requests\Requests::post($url, $headers, json_encode($req));*/
        $response = WpOrg\Requests\Requests::get($url,$headers);
        //use MigrationFileManager as response storage, will be read from new status bar

        $data = $response->decode_body();

        /*success 200
        {
            "id": 0,
            "uuid": "string",
            "idStatus": 0,
            "login": "string",
            "idDomain": 0,
            "domain": "string",
            "user": "string",
            "idDestinationArticle": 0,
            "isManaged": true,
            "startDateUtc": "2023-07-11T14:19:57.471Z",
            "completionDateUtc": "2023-07-11T14:19:57.471Z",
            "idProgressStatus": 0
        }
        fail 400
        {
            "errorCode": 102,
            "errorMessage": "Invalid parameter: is null",
            "errorDetail": "Value cannot be null. (Parameter 'input')"
        }*/

          $GLOBALS["PROCESS_LOG"]->writeLog("Migration Process - First Status Request " . $response->success . " " . $response->status_code);

        // aggiungere chiamata di start
        // controllo per idStatus==1
          if(isset($data['idStatus']) ) {

              if($data['idStatus']===1){
                $start_url = $this->apiUrl . 'start';
              }else if($data['idStatus']===4 || $data['idStatus']===5){
                  $start_url = $this->apiUrl . 'restart';
              }
              $GLOBALS["PROCESS_LOG"]->writeLog($start_url);
              $response = WpOrg\Requests\Requests::post($start_url, $headers);
            //risposta 200 se non è 200 è errore
             /* $resp_code = wp_remote_retrieve_response_code($response);

              if (is_wp_error($response) ||  $resp_code < 200 || $resp_code > 299) {
                  error_log("----- ERROR " . serialize($response));
                  return false;
              }*/

              if($response->status_code===400){
                  $GLOBALS["PROCESS_LOG"]->writeLog("Migration Process - Start Process Request FAIL " . $response->status_code);
                  //$response->throw_for_status(true);//??
              }else{
                  $GLOBALS["PROCESS_LOG"]->writeLog("Migration Process - Start Process Request " . $response->success . " " . $response->status_code);
              }
          }


        return $response->success;
    }
}
