<?php

class MigratorStateDBDump extends MigratorState
{
    private $dbConn;
    private $migrationFolderPath;
    function __construct($dbConn, $migrationFolderPath)
    {
        parent::__construct("creazione dump database");
        $this->dbConn = $dbConn;
        $this->migrationFolderPath = $migrationFolderPath;
    }

    /**
     * crea il dump del database e lo zippa wp-dump.zip
     */
    function execute()
    {
        $GLOBALS["PROCESS_LOG"]->writeLog("Migration Process - Create DB dump");
        $GLOBALS["MIGRATION_FILE_MANAGER"]->updateMigrationKey("WP2WP_MIGRATION_FILES_STATUS", "1");
        $dumper = new MySQLDBDumper($this->dbConn);
        $filePath = $dumper->createDBDump($this->migrationFolderPath . DIRECTORY_SEPARATOR);
        if (!$filePath) {
            $GLOBALS["PROCESS_LOG"]->writeLog("Migration Process - DB dump Error generating export");
          //  $GLOBALS["MIGRATION_FILE_MANAGER"]->updateMigrationKey("WP2WP_MIGRATION_FILES_STATUS", "-1");
            return false;
        }
        // move to prepare packages
        /*$fileObj = ["name" => basename($filePath), "path" => $filePath];
        $fileZipName = basename($fileObj["name"], ".sql");
        $GLOBALS["PROCESS_LOG"]->writeLog("Migration Process - DB dump - compressing dump");
        if (!Utilities::zipFile($fileZipName, $fileObj, $this->migrationFolderPath . DIRECTORY_SEPARATOR)) {
            $GLOBALS["PROCESS_LOG"]->writeLog("Migration Process - DB dump Failed Zip");
            return false;
        }
        if (!unlink($filePath)) {
            $GLOBALS["PROCESS_LOG"]->writeLog("Migration Process - DB dump Delete Fail " . $filePath);
            // TODO: valutare se è un errore bloccante 
        }*/


        $GLOBALS["PROCESS_LOG"]->writeLog("Migration Process - DB dump Saved");
        return true;
    }
}
