<?php

class MigratorStateFinalization extends MigratorState
{
    private $migrationFolderPath;
    function __construct($migrationFolderPath)
    {
        parent::__construct("finalizzazione installazione");
        $this->migrationFolderPath = $migrationFolderPath;
    }

    /**
     * Fa pulizia della cartella di migrazione dopop la migrazione 
     */
    function execute()
    {
        $GLOBALS["PROCESS_LOG"]->writeLog("Migration Process - Cleaning Migration Folder");
        $GLOBALS["MIGRATION_FILE_MANAGER"]->updateMigrationKey("WP2WP_MIGRATION_FILES_STATUS", "6");
        $files = scandir($this->migrationFolderPath);
        $files = array_filter($files, function ($var) {
            return  $var !== "." && $var !== "..";
        });
        foreach ($files as $f) {
            $filePath = $this->migrationFolderPath . DIRECTORY_SEPARATOR . $f;
            $GLOBALS["PROCESS_LOG"]->writeLog("Migration Process - Deleting " . $filePath);
            if (!unlink($filePath)) {
                $GLOBALS["PROCESS_LOG"]->writeLog("Migration Process - Delete Fail " . $filePath);
            }
        }

        return true;
    }
}
