<?php

class  MigratorStatePreparePackages extends MigratorState
{
    private $foldersToCopy;
    private $foldersToExclude;
    private $migrationFolderPath;

    function __construct($foldersToCopy, $foldersToExclude, $migrationFolderPath)
    {
        parent::__construct("creazione pacchetti migrazione");
        $this->foldersToCopy = $foldersToCopy;
        $this->migrationFolderPath = $migrationFolderPath;
        $this->foldersToExclude = $foldersToExclude;
    }

    /**
     * crea due zip 
     *      wp-content.zip - contenente tutta la cartella wp-content
     *      wp-root.zip - contenente tutti i file ecartelle a galla
     */
    function execute()
    {
        set_time_limit(0);
        if (!isset($this->foldersToCopy)) {
            return true;
        }
        $GLOBALS["PROCESS_LOG"]->writeLog("Migration Process - Create Packages");
        $GLOBALS["PROCESS_LOG"]->writeLog("Migration Process - Zip Folder: [" . ABSPATH. "]");
        $GLOBALS["MIGRATION_FILE_MANAGER"]->updateMigrationKey("WP2WP_MIGRATION_FILES_STATUS", "2");




        if (!Utilities::zipFiles("wp", $this->foldersToCopy, $this->migrationFolderPath . DIRECTORY_SEPARATOR)) {
            $GLOBALS["PROCESS_LOG"]->writeLog("Migration Process - Error while creating zip of files of WP root");
            return false;
        }
       // Utilities::zipFolder(ABSPATH, $this->migrationFolderPath . DIRECTORY_SEPARATOR, $this->foldersToExclude);
        $GLOBALS["PROCESS_LOG"]->writeLog("Migration Process - Closing Zip Folder [" . ABSPATH. "]");
        //zip pkg
        $dbarchives = array
        (
            array(
            "name" => "wp-db.sql",
            "path" => $this->migrationFolderPath . DIRECTORY_SEPARATOR . "wp-db.sql"
            )


        );
        $GLOBALS["PROCESS_LOG"]->writeLog("Migration Process - Zip DB: [" .  $this->migrationFolderPath . DIRECTORY_SEPARATOR . "wp-db.sql". "]");
        $GLOBALS["MIGRATION_FILE_MANAGER"]->updateMigrationKey("WP2WP_MIGRATION_FILES_STATUS", "3");

        if (!Utilities::zipFiles("wpdb", $dbarchives, $this->migrationFolderPath . DIRECTORY_SEPARATOR)) {
            
            $GLOBALS["PROCESS_LOG"]->writeLog("Migration Process - Error while creating zip of files");

            //$GLOBALS["MIGRATION_FILE_MANAGER"]->updateMigrationKey("WP2WP_MIGRATION_FILES_STATUS", "-3");
            return false;
        }
        if (!unlink($this->migrationFolderPath . DIRECTORY_SEPARATOR . "wp-db.sql")) {
            $GLOBALS["PROCESS_LOG"]->writeLog("Migration Process - DB dump Delete Fail " . $this->migrationFolderPath . DIRECTORY_SEPARATOR . "wp-db.sql");
          
        }
        $GLOBALS["PROCESS_LOG"]->writeLog("Migration Process - Packages Created");

        return true;
    }
}
