<?php

class MySQLDBDumper
{
    private $dbConn;
    function __construct($dbConn)
    {
        $this->dbConn = $dbConn;
    }

    public function createDBDump($fileDestination)
    {
        $conn = mysqli_connect($this->dbConn["dbhost"], $this->dbConn["dbuser"], $this->dbConn["dbpassword"], $this->dbConn["dbname"]);
        $conn->set_charset("utf8");

        $GLOBALS["PROCESS_LOG"]->writeLog("Migration Process - DB Connected ");

        // Get All Table Names From the Database
        $tables = array();
        $sql = "SHOW TABLES";
        $result = mysqli_query($conn, $sql);

        while ($row = mysqli_fetch_row($result)) {
            $tables[] = $row[0];
        }

        $sqlScript = "";
        foreach ($tables as $table) {
            // Prepare SQLscript for creating table structure
            $query = "SHOW CREATE TABLE $table";
            $result = mysqli_query($conn, $query);
            $row = mysqli_fetch_row($result);

            $sqlScript .= "\n\n" . $row[1] . ";\n\n";

            $query = "SELECT * FROM $table";
            $result = mysqli_query($conn, $query);

            $columnCount = mysqli_num_fields($result);

            // Prepare SQLscript for dumping data for each table
            for ($i = 0; $i < $columnCount; $i++) {
                while ($row = mysqli_fetch_row($result)) {
                    $sqlScript .= "INSERT INTO $table VALUES(";
                    for ($j = 0; $j < $columnCount; $j++) {
                        $row[$j] = $row[$j];

                        if (isset($row[$j])) {
                            $sqlScript .= '"' . addslashes($row[$j]) . '"';
                        } else {
                            $sqlScript .= '""';
                        }
                        if ($j < ($columnCount - 1)) {
                            $sqlScript .= ',';
                        }
                    }
                    $sqlScript .= ");\n";
                }
            }
            $sqlScript .= "\n";
        }

        $GLOBALS["PROCESS_LOG"]->writeLog("Migration Process - DB dump Created");

        $backup_file_name = $fileDestination . 'wp-db.sql';

        $GLOBALS["PROCESS_LOG"]->writeLog("Migration Process - Saving in to $backup_file_name");

        $fileHandler = fopen($backup_file_name, 'w+');
        $number_of_lines = fwrite($fileHandler, $sqlScript);
        if (!fclose($fileHandler)) {
            $GLOBALS["PROCESS_LOG"]->writeLog("Migration Process - Error closing file");
            return false;
        }
        return $backup_file_name;
    }
}
