<?php

use \Aws\S3\S3Client;
use \Aws\S3\MultipartUploader;
use \Aws\Exception\MultipartUploadException;

class ORCUploader
{
    private $file_path ;
    private $api_endpoint ;
    private $bearer_token ;

    function __construct()
    {

        
    }
/*
    public function upload($file_path, $api_endpoint , $bearer_token)
    {
        try
        {
        $file = new CURLFile($file_path);

            // Create the POST data
            $post_data = array(
                'file' => $file,
            );
            // Create a new FormData instance
            $form_data = new \CURLFile($file_path);
            
            if (!empty($file_path) && is_file($file_path)){
                $form_data = new CURLFile($file_path);
            }
            //$content = file_get_contents($file_path);


            $file_field_name = 'file';
            // Initialize cURL
            $ch = curl_init();

            // Set the POST parameters for the file upload
            curl_setopt($ch, CURLOPT_URL, $api_endpoint);
            curl_setopt($ch, CURLOPT_POST, true);
            curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
            curl_setopt($ch, CURLOPT_SSL_VERIFYPEER,false);
            curl_setopt($ch, CURLOPT_SSL_VERIFYHOST,false);
            //curl_setopt($ch, CURLOPT_POSTFIELDS, $post_data);
            curl_setopt($ch, CURLOPT_POSTFIELDS, array(
                $file_field_name => $form_data,
            ));
           

            // Set the Authorization header with the bearer token
            curl_setopt($ch, CURLOPT_HTTPHEADER, array(
                "Authorization: Bearer $bearer_token",
            ));

            // Execute the request
            $response = curl_exec($ch);
            $error = curl_error($ch);
            // Handle the response as per your requirements
            $GLOBALS["PROCESS_LOG"]->writeLog(" CUL UPLOAD RESPONSE: ".$response);
            $GLOBALS["PROCESS_LOG"]->writeLog(" CUL UPLOAD ERROR: ".$error);
            // Close the cURL session
            curl_close($ch);
        }catch(Exception $upex)
        {
            return false;
        }

        return true;

    }*/

    public function create_chunk_for_datachunk ($data,$bearer_token,$part,$lastPart,$fname): array
    {
        $headers = array();
        //"Content-Disposition: form-data; name=\"file\"; filename=\"blob\"",
        $GLOBALS["PROCESS_LOG"]->writeLog("UPLOAD CHUNK OPTIONS FILE NAME: $fname");
        $form[]=implode("\r\n", array(
            "Content-Disposition: form-data; name=\"file\"; filename=\"$fname\"",
            "Content-Type: application/octet-stream",
            "",
            $data
        ));

        do {
            $boundary = "---------------------" . md5(mt_rand() . microtime());
        } while (preg_grep("/{$boundary}/", $form));

        array_walk($form, function (&$_part) use ($boundary) {
            $_part = "--{$boundary}\r\n{$_part}";
        });

        // add final boundary
        $form[] = "--{$boundary}--";
        $form[] = "";

        // set options
        $headers[] ="Content-Type: multipart/form-data; boundary={$boundary}";
        $headers[] ="Authorization: Bearer $bearer_token";
        $headers[] ="partNumber: $part";
        $headers[] ="lastPart: $lastPart";

        return array($headers, $form);
    }

    //Chunk/Stream but api not supported
    public function uploadchunks($file_path, $api_endpoint , $bearer_token)
    {
        set_time_limit(0);

        try{

        $file_size = filesize($file_path);
        $ch = new WP_Http();

            // Open the file in read-only mode
            $handle = fopen($file_path, "rb");
            // Set the chunk size (you can adjust this as per your requirements)
            $chunk_size = 5 * 1024 * 1024; // 5 MB
            //$chunk_size = 800 * 1024; // 800kb
            // Initialize variables
            $start = 0;
            $end = $chunk_size ;
            $part=1;
            $lastPart=( ( ($start + $chunk_size) >= $file_size)?"true":"false" );
            while (!feof($handle)) {

                $GLOBALS["PROCESS_LOG"]->writeLog("UPLOAD CHUNK OPTIONS partNumber: $part");
                $GLOBALS["PROCESS_LOG"]->writeLog("UPLOAD CHUNK OPTIONS lastPart: $lastPart");
                $GLOBALS["PROCESS_LOG"]->writeLog("UPLOAD CHUNK OPTIONS start-end : $start-$end/$file_size");
                // Seek to the start position of the chunk
                fseek($handle, $start);
                // Read the chunk data
                $data = fread($handle, $chunk_size);
                // Set the chunk data for the request
                list($headers, $form) = $this->create_chunk_for_datachunk($data,$bearer_token,$part,$lastPart,basename($file_path));


                try{


                  $response = $ch->request($api_endpoint, array('headers'=>implode("\r\n", $headers) ,'method'=>'POST','body' =>implode("\r\n", $form),'sslverify'=>false,'timeout'=>300));
                  $http_code = $response['response']['code'];
                  if (isset($response->errors)) {
                      $GLOBALS["PROCESS_LOG"]->writeLog('UPLOAD CHUNK ERROR: ', $response->errors->get_error_message());
                      throw new Exception('UPLOAD CHUNK ERROR: '.$response->errors->get_error_message(), $http_code);
                  }elseif ($http_code!==200) {
                      $GLOBALS["PROCESS_LOG"]->writeLog('UPLOAD CHUNK ERROR HTTP: '.$http_code, $http_code);
                      throw new Exception('UPLOAD CHUNK ERROR HTTP: '.$http_code, $http_code);
                  }
                }catch (Exception $cc_upex){
                    $GLOBALS["PROCESS_LOG"]->writeLog("UPLOAD CHUNK EXCEPTION : ".$cc_upex->getMessage());
                    return false;
                }
                // Calculate the start and end positions for the next chunk
                $start = $end;
                $end = $start + $chunk_size ;
                $part++;
                $lastPart=( ( ($start + $chunk_size) >= $file_size)?"true":"false" );
            }
            
            // Close the file handle
            fclose($handle);

        }catch(Exception $gc_upex)
        {
            $GLOBALS["PROCESS_LOG"]->writeLog("UPLOAD CHUNK GENERAL EXCEPTION : ".$gc_upex->getMessage());
            return false;
        }
        return true;

    }


}

?>