<?php
require_once __DIR__ . '/../../vendor/autoload.php';
require_once __DIR__ . "/classes/migration-log.php";
require_once __DIR__ . "/classes/utilities.php";
require_once __DIR__ . "/classes/mysql-db-dumper.php";
require_once __DIR__ . "/classes/aruba-migrator.php";
//require_once __DIR__ . "/classes/s3-client-wrapper.php";
require_once __DIR__ . "/classes/migrator-state/migrator-state.php";
require_once __DIR__ . "/classes/migrator-state/migrator-state-enable-maintenance.php";
require_once __DIR__ . "/classes/migrator-state/migrator-state-db-dump.php";
require_once __DIR__ . "/classes/migrator-state/migrator-state-prepare-packages.php";
require_once __DIR__ . "/classes/migrator-state/migrator-state-upload.php";
require_once __DIR__ . "/classes/migrator-state/migrator-state-call-orchestrator.php";
require_once __DIR__ . "/classes/migrator-state/migrator-state-finalization.php";
require_once __DIR__ . "/../common-classes/migration-file-manager.php";
require_once __DIR__ . "/../common-classes/migration-progression-info.php";


$required = ["token", "apiUrl", "jwt", "maintenance", "backup", "logFilePath", "migrationFilePath", "migrationFolderPath", "foldersToCopy", "dbConn"];
//$migrationParams;

if (count($argv) < 1) {
    error_log("Missing parameters");
    die();
}
foreach ($argv as $key => $a) {
    $nextId = $key + 1;
    if ($a == "-m") {
        if ($nextId < count($argv)) {
            $migrationParams = $argv[$nextId];
            if (!isset($migrationParams)) {
                die("m is not a json");
            }
        } else {
            die("Missing value of parameters m");
        }
    }
}

if (!isset($migrationParams)) {
    die("Missing parameters");
}

$migrationParams = base64_decode($migrationParams);
$migrationParams = unserialize($migrationParams);

if (count(array_intersect_key(array_flip($required), $migrationParams)) !== count($required)) {
    die("Missing Migration Param");
}


$GLOBALS["PROCESS_LOG"] = new MigrationLog($migrationParams["logFilePath"]);
$GLOBALS["MIGRATION_FILE_MANAGER"] = new MigrationFileManager($migrationParams["migrationFilePath"]);

//$GLOBALS["PROCESS_LOG"]->writeLog("Migration Process - Initialization: " . serialize($migrationParams));


$migrator = new ArubaMigrator($migrationParams);
$migrator->start();
