<?php


class AWMT_VerifyTokenStep extends AWMT_MigrationStep
{
    function __construct(){
        parent::__construct(1, __("Token",'aruba-wp-migration-tool'));
    }

    function draw(){
	    wp_enqueue_script(
		    'verify-token-step',
		    WP_PLUGIN_URL .'/aruba-wp-migration-tool/src/migration-plugin/assets/js/verify-token-step.js',
		    array('jquery'),
		    filemtime( WP_PLUGIN_DIR.'/aruba-wp-migration-tool/src/migration-plugin/assets/js/verify-token-step.js' ),
		    array(
			    'strategy'  => 'async',
			    'in_footer'=>true
		    )
	    );
	    $js_param = array(
		    'awmt_ajax_error_desc' => esc_html(__("The token cannot be empty", "aruba-wp-migration-tool"))
	    );
	    wp_add_inline_script( 'verify-token-step', 'const awmt_verify_token_param = ' . wp_json_encode( $js_param ), 'before' );


	    $msg = "";
        $errorMessage="";
        // phpcs:ignore WordPress.Security.NonceVerification.Recommended
        if (isset($_GET['err-gen']) ) {
          echo wp_kses_post("<div class='notice notice-error '> <!-- is-dismissible-->
          <p>".esc_html(__("An application error has occurred. We suggest you try again in a few minutes. For more information",'aruba-wp-migration-tool'))."<a href=\'".esc_url(AWMT_ARUBA_CLIENT_AREA_URL)." \'>".esc_html(__("contact technical support",'aruba-wp-migration-tool'))." </a></p>
          </div>");
        }
        // phpcs:ignore WordPress.Security.NonceVerification.Recommended
	    if (isset(  $_GET['err-inv-token']) ) {
            // phpcs:ignore WordPress.Security.NonceVerification.Recommended
		    switch (sanitize_text_field($_GET['err-inv-token'])) {
                case 42001:
                    $msg = esc_html(__("Token does not exist.", "aruba-wp-migration-tool"));
                    break;
                case 42002:
                    $msg = esc_html(__("Token already used.", "aruba-wp-migration-tool"));
                    break;
                case 42003:
                    $msg = esc_html(__("Token expired.", "aruba-wp-migration-tool")); ;
                    break;
                default :
                    $msg="";
                    break;
            }
        }

	    $inputValue = "";
        if (!empty($_SESSION['wp2wp-migration-token'])) {
            $inputValue = sanitize_text_field($_SESSION['wp2wp-migration-token']);
        }
		?>
        <form id='verifytoken' name='verifytoken' method='GET' action="<?php echo esc_url(admin_url('admin-post.php'))?>">
                    <div class='insert-token-form-content'>
                        <div>
                            <label for='token-input'><?php echo esc_html( __("Migration Token", "aruba-wp-migration-tool") )?></label>
                            <input type='text' placeholder='Aruba migration token' value='<?php echo esc_attr( $inputValue) ?>' id='token-input' name='token-input'>
                            <input type='hidden' name='action' value='add_token'>
                            <input type='hidden' id='add_token_nonce' name='add_token_nonce' value="<?php echo esc_attr( wp_create_nonce('add_token' ))?>">
                            <p class='wp2wp-text-notification'><?php echo esc_html($msg) ?></p>
                        </div>
                        <div>
                            <b><?php echo esc_html(__("Don’t have a token?", "aruba-wp-migration-tool") )?></b>
                            <p><?php echo esc_html(__("Sign in to your Aruba Hosting customer area. Go to your domain control panel and click on WordPress Migration. Generate the token required in the Token area.", "aruba-wp-migration-tool") )?></p>
                        </div>
                    </div>
                    <hr class='wp2wp-mb wp2wp-mt'>
                    <button class='button-primary pull-right' type='button' id='submitbutton'><label><?php echo esc_html(__('Continue','aruba-wp-migration-tool'))?></label>&nbsp;<i class='fa fa-circle-o-notch fa-spin' style='display:none'></i></button>
                </form>
<?php
    }
}
