<?php
class AWMT_WPFSWrapper
{
    private $wp_fs;
    function __construct()
    {
        global $wp_filesystem;
        require_once ABSPATH . 'wp-admin/includes/file.php';
        WP_Filesystem();
        $this->wp_fs = $wp_filesystem;
    }

    public function deleteFolder($folderPath)
    {
        if ($this->wp_fs->is_dir($folderPath)) {
            return $this->wp_fs->rmdir($folderPath, true);
        }
        return true;
    }

    public function createFolder($folderPath)
    {
        $created = null;
        if (!$this->wp_fs->is_dir($folderPath)) {
            $created = $this->wp_fs->mkdir($folderPath);
            if (!$created || !$this->wp_fs->is_dir($folderPath)) {
                error_log("ERROR -- Non posso creare Directory");
                return new WP_Error('no_dir', __("Failed to create directory - please check your file permissions and enable the access" , "aruba-wp-migration-tool") . $folderPath);
            }
        }
        return $created;
    }


    public function createFile($filePath, $message = "", $permissions = 0775)
    {
        if ($this->wp_fs->is_file($filePath)) {
            $this->wp_fs->delete($filePath);
        }
        $created = $this->wp_fs->put_contents($filePath, $message, $permissions);
        if (!$created || !$this->wp_fs->is_file($filePath)) {
            error_log("ERROR -- Non posso creare File");
            return new WP_Error('no_dir',  __("Failed to create file - please check your file permissions and enable the access" , "aruba-wp-migration-tool") . $filePath);
        }
        return true;
    }
}
