<?php

class AWMT_MigratorStateDBDump extends AWMT_MigratorState
{
    private $dbConn;
    private $migrationFolderPath;
    function __construct($dbConn, $migrationFolderPath)
    {
        parent::__construct("creazione dump database");
        $this->dbConn = $dbConn;
        $this->migrationFolderPath = $migrationFolderPath;
    }

    /**
     * crea il dump del database e lo zippa wp-dump.zip
     */
    function execute()
    {
        $GLOBALS["AWMT_PROCESS_LOG"]->writeLog("Migration Process - Create DB dump");
        $GLOBALS["AWMT_MIGRATION_FILE_MANAGER"]->updateMigrationKey("WP2WP_MIGRATION_FILES_STATUS", "1");
        $dumper = new AWMT_MySQLDBDumper($this->dbConn);
        $filePath = $dumper->createDBDump($this->migrationFolderPath . DIRECTORY_SEPARATOR);
        if (!$filePath) {
            $GLOBALS["AWMT_PROCESS_LOG"]->writeLog("Migration Process - DB dump Error generating export");
          //  $GLOBALS["AWMT_MIGRATION_FILE_MANAGER"]->updateMigrationKey("WP2WP_MIGRATION_FILES_STATUS", "-1");
            return false;
        }
        $GLOBALS["AWMT_PROCESS_LOG"]->writeLog("Migration Process - DB dump Saved");
        return true;
    }
}
