<?php

class AWMT_MigratorStateUpload extends AWMT_MigratorState
{
    private $migrationFolderPath;
    private $_jwt;
    function __construct($migrationFolderPath, $jwt)
    {
        parent::__construct("upload");
        $this->migrationFolderPath = $migrationFolderPath;
        $this->_jwt = $jwt;
    }

    /**
     * Carica gli zip creati su s3
     */
    function execute()
    {
        set_time_limit(0);
       // $success = true;
        $GLOBALS["AWMT_PROCESS_LOG"]->writeLog("Migration Process - Init API Upload ");
        //Content upload

            try
            {
                $files = AWMT_Utilities::scanDir($this->migrationFolderPath);
                $files = array_map(function ($v) {
                    return ["name" =>  $v, "path" => $this->migrationFolderPath . DIRECTORY_SEPARATOR . $v];
                }, $files);
                $GLOBALS["AWMT_PROCESS_LOG"]->writeLog("Migration Process - Start Upload");
                $endpointwc = AWMT_API_URL . "migration/uploaddatapart";
                $endpointdb = AWMT_API_URL . "migration/uploaddbpart";

                $GLOBALS["AWMT_PROCESS_LOG"]->writeLog(" WORDPRESS API: ".$endpointwc);
                $GLOBALS["AWMT_PROCESS_LOG"]->writeLog(" DATABASE API: ".$endpointdb);

                //$filepath = AWMT_PROCESS_FOLDER_PATH . DIRECTORY_SEPARATOR . 'gigafile.zip';
                $uploader = new AWMT_ORCUploader();
                //$uploader->upload( $filepath, $endpoint  , $_SESSION["wp2wp-jwt"]);
	            $wp_uploded=false;
	            $db_uploded=false;

				while( !$wp_uploded || !$db_uploded){

                $GLOBALS["AWMT_PROCESS_LOG"]->writeLog("Migration Process - Upload data : ".$this->migrationFolderPath . DIRECTORY_SEPARATOR . "wp.zip");
                $GLOBALS["AWMT_MIGRATION_FILE_MANAGER"]->updateMigrationKey("WP2WP_MIGRATION_FILES_STATUS", "4");


                //$uploader->upload
                if(!$uploader->uploadchunks( $this->migrationFolderPath . DIRECTORY_SEPARATOR . "wp.zip", $endpointwc  , $this->_jwt) && !$wp_uploded)
                {
                    $GLOBALS["AWMT_PROCESS_LOG"]->writeLog("Migration Process - API Upload Content Error " . "wp.zip");
                    return false;
                }else{
	                $wp_uploded=true;
                }
                //sleep(2);
                $GLOBALS["AWMT_PROCESS_LOG"]->writeLog("Migration Process - Upload DB : ".$this->migrationFolderPath . DIRECTORY_SEPARATOR . "wpdb.zip");
                $GLOBALS["AWMT_MIGRATION_FILE_MANAGER"]->updateMigrationKey("WP2WP_MIGRATION_FILES_STATUS", "5");
                //!$uploader->upload
                if(!$uploader->uploadchunks( $this->migrationFolderPath . DIRECTORY_SEPARATOR . "wpdb.zip", $endpointdb  , $this->_jwt) && !$db_uploded)
                {
                    $GLOBALS["AWMT_PROCESS_LOG"]->writeLog("Migration Process - API Upload Content Error " . "wpdb.zip");
                    return false;
                }else{
	                $db_uploded=true;
                }
					$GLOBALS["AWMT_PROCESS_LOG"]->writeLog("Migration Process - WP UPLODED " .$wp_uploded);
					$GLOBALS["AWMT_PROCESS_LOG"]->writeLog("Migration Process - DB UPLODED " .$db_uploded);
					if($wp_uploded && $db_uploded){
						//mettere le chiamate di state-call-orchestratore

						$GLOBALS["AWMT_PROCESS_LOG"]->writeLog("Migration Process - Chiamata orchestratore ");

						$headers = array(
							'Content-Type' => 'application/json',
							'Authorization' => "Bearer " .  $_SESSION['wp2wp-jwt']
						);
                        $url =AWMT_API_URL . 'detail';
                        $GLOBALS["AWMT_PROCESS_LOG"]->writeLog($url);

                        $response = WpOrg\Requests\Requests::get($url,$headers);
                        $data = $response->decode_body();

                        if(isset($data['idStatus']) ) {
                           /* if ($data['idStatus'] === 1 || $data['idStatus'] === 9) {
                                $start_url = AWMT_API_URL . 'start';
                            } else*/
                            if ($data['idStatus'] === 4 || $data['idStatus'] === 5) {
                                $start_url = AWMT_API_URL . 'restart';
                            }else{
                                // nessun stato valido forzo lo start
                                $start_url = AWMT_API_URL . 'start';
                            }
                        }else{
                            // nessun stato trovato forzo lo start
                            $start_url = AWMT_API_URL . 'start';
                        }
						$GLOBALS["AWMT_PROCESS_LOG"]->writeLog($start_url);
						$response = WpOrg\Requests\Requests::post($start_url, $headers);
						$GLOBALS["AWMT_PROCESS_LOG"]->writeLog("Migration Process - First Status Request " . $response->success . " " . $response->status_code);

						if($response->status_code===400){
							$GLOBALS["AWMT_PROCESS_LOG"]->writeLog("Migration Process - Start Process Request FAIL " . $response->status_code);
							return false;
						}else{
							$GLOBALS["AWMT_PROCESS_LOG"]->writeLog("Migration Process - Start Process Request " . $response->success . " " . $response->status_code);
						}
					}

				}

            }catch(Exception $uce)
            {
                $GLOBALS["AWMT_PROCESS_LOG"]->writeLog("Migration Process - API Upload Content Error " . $uce->getMessage());
                return false;
            };
        $GLOBALS["AWMT_PROCESS_LOG"]->writeLog("Migration Process - Files Uploaded");


        return true;
    }
}