<?php
class AWMT_MySQLDBDumper {
	private $dbConn;

	function __construct( $dbConn ) {
		$this->dbConn = $dbConn;
	}

	// phpcs:disable
	public function createDBDump( $fileDestination ) {
		global $wpdb;
		// Get All Table Names From the Database
		$tables = array();
		$rows   = $wpdb->tables();
		foreach ( $rows as $g_name => $table_row ) {
			$tables[] = $table_row;
		}
		$GLOBALS["AWMT_PROCESS_LOG"]->writeLog( $tables );
		$sqlScript = "";
		foreach ( $tables as $table ) {
			// Prepare SQLscript for creating table structure
			$row_table = wp_cache_get( 'awp2wp_show_' . $table, 'awp2wp' );
			if ( ! $row_table ) {
				// phpcs:ignore WordPress.DB.DirectDatabaseQuery.DirectQuery
				$row_table = $wpdb->get_row( $wpdb->prepare( "SHOW CREATE TABLE %i", [ $table ] ), ARRAY_N );
				wp_cache_set( 'awp2wp_show_' . $table, $row_table, 'awp2wp', 5 * MINUTE_IN_SECONDS );
			}
			$sqlScript .= "\n\n" . $row_table[1] . ";\n\n";
			$columns   = [];
			$_columns  = wp_cache_get( 'awp2wp_columns_' . $table, 'awp2wp' );
			if ( ! $_columns ) {
				// phpcs:ignore WordPress.DB.DirectDatabaseQuery.DirectQuery
				$_columns = $wpdb->get_col( $wpdb->prepare( "DESC %i", [ $table ] ), 0 );
				wp_cache_set( 'awp2wp_columns_' . $table, $_columns, 'awp2wp', 5 * MINUTE_IN_SECONDS );
			}
			foreach ( $_columns as $column_name ) {
				$columns[] = $column_name;
			}
			$columnCount = count( $columns );
			$res         = wp_cache_get( 'awp2wp_res_' . $table, 'awp2wp' );
			if ( ! $res ) {
				// phpcs:ignore WordPress.DB.DirectDatabaseQuery.DirectQuery
				$res = $wpdb->get_results( $wpdb->prepare( "SELECT * FROM %i", [ $table ] ), ARRAY_N );
				wp_cache_set( 'awp2wp_res_' . $table, $res, 'awp2wp', 5 * MINUTE_IN_SECONDS );
			}

			foreach ( $res as $row ) {
				$sqlScript .= "INSERT INTO $table VALUES(";
				for ( $j = 0; $j < $columnCount; $j ++ ) {
					if ( isset( $row[ $j ] ) ) {
						$sqlScript .= '"' . addslashes( $row[ $j ] ) . '"';
					} else {
						$sqlScript .= '""';
					}
					if ( $j < ( $columnCount - 1 ) ) {
						$sqlScript .= ',';
					}
				}
				$sqlScript .= ");\n";
			}
			$sqlScript .= "\n";
			wp_cache_delete( 'awp2wp_show_' . $table, 'awp2wp' );
			wp_cache_delete( 'awp2wp_columns_' . $table, 'awp2wp' );
			wp_cache_delete( 'awp2wp_res_' . $table, 'awp2wp' );
		}

		$GLOBALS["AWMT_PROCESS_LOG"]->writeLog( "Migration Process - DB dump Created" );
		$backup_file_name = $fileDestination . 'wp-db.sql';
		$GLOBALS["AWMT_PROCESS_LOG"]->writeLog( "Migration Process - Saving in to $backup_file_name" );

		require_once ABSPATH . 'wp-admin/includes/class-wp-filesystem-base.php';
		require_once ABSPATH . 'wp-admin/includes/class-wp-filesystem-direct.php';
		$wp_filesystem = new WP_Filesystem_Direct( null );
		if ( ! $wp_filesystem->put_contents( $backup_file_name, $sqlScript, 0664 ) ) {
			$GLOBALS["AWMT_PROCESS_LOG"]->writeLog( "Migration Process - Error creating file" );

			return false;
		}

		return $backup_file_name;
	}
	// phpcs:enable
}
