<?php
/*
use \Aws\S3\S3Client;
use \Aws\S3\MultipartUploader;
use \Aws\Exception\MultipartUploadException;
*/
class AWMT_ORCUploader
{
    function __construct()
    {

    }

    public function create_chunk_for_datachunk ($data,$bearer_token,$part,$lastPart,$fname)
    {
        $headers = array();
        //"Content-Disposition: form-data; name=\"file\"; filename=\"blob\"",
        $GLOBALS["AWMT_PROCESS_LOG"]->writeLog("UPLOAD CHUNK OPTIONS FILE NAME: $fname");
        $form[]=implode("\r\n", array(
            "Content-Disposition: form-data; name=\"file\"; filename=\"$fname\"",
            "Content-Type: application/octet-stream",
            "",
            $data
        ));

        do {
            $boundary = "---------------------" . md5(wp_rand() . microtime());
        } while (preg_grep("/{$boundary}/", $form));

        array_walk($form, function (&$_part) use ($boundary) {
            $_part = "--{$boundary}\r\n{$_part}";
        });

        // add final boundary
        $form[] = "--{$boundary}--";
        $form[] = "";

        // set options
        $headers[] ="Content-Type: multipart/form-data; boundary={$boundary}";
        $headers[] ="Authorization: Bearer $bearer_token";
        $headers[] ="partNumber: $part";
        $headers[] ="lastPart: $lastPart";

        return array($headers, $form);
    }

    //Chunk/Stream but api not supported
    public function uploadchunks($file_path, $api_endpoint , $bearer_token)
    {
        set_time_limit(0);

        try{

        $file_size = filesize($file_path);
        $ch = new WP_Http();

            // Open the file in read-only mode
            // phpcs:ignore WordPress.WP.AlternativeFunctions.file_system_operations_fopen
            $handle = fopen($file_path, "rb");
            // Set the chunk size (you can adjust this as per your requirements)
            $chunk_size = 5 * 1024 * 1024; // 5 MB
            // Initialize variables
            $start = 0;
            $end = $chunk_size ;
            $part=1;
            $lastPart=( ( ($start + $chunk_size) >= $file_size)?"true":"false" );
            while (!feof($handle)) {

                $GLOBALS["AWMT_PROCESS_LOG"]->writeLog("UPLOAD CHUNK OPTIONS partNumber: $part");
                $GLOBALS["AWMT_PROCESS_LOG"]->writeLog("UPLOAD CHUNK OPTIONS lastPart: $lastPart");
                $GLOBALS["AWMT_PROCESS_LOG"]->writeLog("UPLOAD CHUNK OPTIONS start-end : $start-$end/$file_size");
                // Seek to the start position of the chunk
                fseek($handle, $start);
                // Read the chunk data
                // phpcs:ignore WordPress.WP.AlternativeFunctions.file_system_operations_fread
                $data = fread($handle, $chunk_size);
                // Set the chunk data for the request
                list($headers, $form) = $this->create_chunk_for_datachunk($data,$bearer_token,$part,$lastPart,basename($file_path));

                try{
                  $response = $ch->request($api_endpoint, array('headers'=>implode("\r\n", $headers) ,'method'=>'POST','body' =>implode("\r\n", $form),'sslverify'=>false,'timeout'=>300));
				  if(!is_wp_error($response)){
				    $GLOBALS["AWMT_PROCESS_LOG"]->writeLog("CHUNK REQUEST RESPONSE: ".$response['response']['code']);
	                $http_code = $response['response']['code'];
				  }

				  if (is_wp_error($response) || $http_code!==200) {
                      // qui mettere il retry
                      $GLOBALS["AWMT_PROCESS_LOG"]->writeLog('RETRY UPLOAD CHUNK ');
                      sleep(1);
                      $retry=1;
                      $uploded=false;
                      while($retry<=3 || $uploded){
                          $GLOBALS["AWMT_PROCESS_LOG"]->writeLog('RETRY UPLOAD CHUNK n.'.$retry);
	                      $response = $ch->request($api_endpoint, array('headers'=>implode("\r\n", $headers) ,'method'=>'POST','body' =>implode("\r\n", $form),'sslverify'=>false,'timeout'=>300));

						  if(!is_wp_error($response) && (isset($response['response']['code']) && $response['response']['code']==200)){
                              $GLOBALS["AWMT_PROCESS_LOG"]->writeLog('RETRY UPLOAD CHUNK n.'.$retry." OK continue");
                              $uploded=true;
                          }else{
                              $GLOBALS["AWMT_PROCESS_LOG"]->writeLog('RETRY UPLOAD CHUNK n.'.$retry." KO retry");
		                      if($retry==3 && !$uploded){
			                      //$GLOBALS["AWMT_PROCESS_LOG"]->writeLog('UPLOAD CHUNK ERROR HTTP FINAL: '. serialize($response));
			                      throw new Exception('UPLOAD CHUNK ERROR HTTP FINAL: '.serialize($response));

		                      }
                              $retry++;
                          }
                      }
                  }
                }catch (Exception $cc_upex){
                    $GLOBALS["AWMT_PROCESS_LOG"]->writeLog("UPLOAD CHUNK EXCEPTION : ".$cc_upex->getMessage());
                    return false;
                }
                // Calculate the start and end positions for the next chunk
                $start = $end;
                $end = $start + $chunk_size ;
                $part++;
                $lastPart=( ( ($start + $chunk_size) >= $file_size)?"true":"false" );
            }

            // Close the file handle
            // phpcs:ignore WordPress.WP.AlternativeFunctions.file_system_operations_fclose
            fclose($handle);

	        //aruba

        }catch(Exception $gc_upex)
        {
            $GLOBALS["AWMT_PROCESS_LOG"]->writeLog("UPLOAD CHUNK GENERAL EXCEPTION : ".$gc_upex->getMessage());
            return false;
        }
        return true;
    }

}